import { connect } from "umi";
import type { CurrentUser } from "umi";
import type { ConnectState } from "@/models/connect";
import React, { useRef, useState } from "react";
import ProCard from "@ant-design/pro-card";
import { MenuFoldOutlined } from "@ant-design/icons";
import type { FormInst, nce } from "antd";
import { TreeSelect } from "antd";
import { Button, message, Space, Spin, Tree } from "antd";
import useRequest from "@ahooksjs/use-request";
import { getFieldEnumTree, getServerpartTree, getSPRegionShopTree, handleCallLogs, handleGetServiceShopTreeList } from "@/services/options";
import type { ActionType } from "@ant-design/pro-table";
import ProTable from "@ant-design/pro-table";
import ReactHTMLTableToExcel from "react-html-table-to-excel";
import session from "@/utils/session";
import moment from "moment/moment";
import {
  handleGetCommodityTypeSummary,
  handleGetNestingCOMMODITYTYPETree,
  handleGetServerpartShopTrade
} from "@/pages/reports/BusinessAnalysis/saleTypeReport/service";
import { handleGetBusinessTrades } from "./service";
import ProDescriptions from "@ant-design/pro-descriptions";
import numeral from "numeral";
import PageTitleBox from "@/components/PageTitleBox";
import { exportXlsxFromProColumnsExcelJS } from "@/utils/exportExcelFun";
import { formatTreeData } from "@/utils/format";


const saleReport: React.FC<{ currentUser: CurrentUser }> = (props) => {
  const { currentUser } = props
  const downloadBtnRef = useRef<any>()
  const actionRef = useRef<ActionType>();
  const formRef = useRef<FormInstance>();
  const [reqDetailList, setReqDetailList] = useState<any>(); // 合计项数据源
  const [printOut, setPrintOut] = useState<any>(); // 打印数据的内容
  const [collapsible, setCollapsible] = useState<boolean>(false)
  const [treeView, setTreeView] = useState<any>()
  // 加载服务区树
  const { loading: treeLoading, data: treeViews } = useRequest(async () => {
    const data = await handleGetServiceShopTreeList({
      ProvinceCode: currentUser?.ProvinceCode,
      BusinessState: "1000,2000,3000",
      ShowState: true,
      SortStr: 'BUSINESS_STATE,SHOPSHORTNAME'
    });
    setTreeView(data)
    return data
  })
  // 树相关的属性和方法
  const [selectedId, setSelectedId] = useState<string>()
  // 导出的加载效果
  const [showLoading, setShowLoading] = useState<boolean>(false)
  // 是否显示打印的表格
  const [showExportTable, setShowExportTable] = useState<boolean>(false)
  // 判断是不是第一次进入页面
  const [isFirst, setIsFirst] = useState<boolean>(true)
  const [printIndex, setPrintIndex] = useState<number>(new Date().getTime())

  const businessTypeObj = session.get("BUSINESSTYPEObj")
  // 商品类别
  const [commodityTypeList, setCommodityTypeList] = useState<any>()
  // 商品类别的选择值
  const [commodityTypeValue, setCommodityTypeValue] = useState<any>()

  // 商品业态列表
  const [commodityFormatsObj, setCommodityFormatsObj] = useState<any>()
  // 表格数据
  const [tableData, setTableData] = useState<any>()


  const { loading: nestLoading, data: nestList } = useRequest(async () => {
    const req = {
      PROVINCE_CODE: currentUser?.ProvinceCode,
      ShowCode: true
    }
    const data = await handleGetNestingCOMMODITYTYPETree(req)
    console.log('data2', data)
    setCommodityTypeList(data)
  })

  const columns: any = [
    {
      title: '统计时间',
      dataIndex: 'search_date',
      valueType: 'dateRange',
      hideInTable: true,
      hideInDescriptions: true,
      initialValue: [moment().add(-1, 'day'), moment().add(-1, 'day')],
      search: {
        transform: (value) => {
          return {
            startDate: value[0],
            endDate: value[1],
          };
        },
      },
      fieldProps: {
        disabledDate: (current: any) => current && current > moment().endOf('day')
      }
    },
    {
      title: '商品类别',
      dataIndex: 'commodityType',
      hideInTable: true,
      renderFormItem: () => {
        return (
          <TreeSelect
            treeData={commodityTypeList}
            allowClear
            treeCheckable
            showCheckedStrategy={TreeSelect.SHOW_PARENT} // 或你需要的策略
            onChange={(e) => {
              if (e) setCommodityTypeValue(e.toString())
              else setCommodityTypeValue(undefined)
            }}
            maxTagCount={2} // 只在选择框中展示最多 2 个 tag
            maxTagPlaceholder={(omittedValues) => `+${omittedValues.length}...`} // 多余用 +N 显示
            style={{ width: '100%' }}
            placeholder="请选择"
          />
        )
      }
    },
    {
      title: '经营模式',
      width: 150,
      dataIndex: 'BusinessType',
      hideInTable: true,
      valueType: 'select',
      valueEnum: businessTypeObj,
    },
    {
      title: '商品业态',
      dataIndex: 'shopTrade',
      hideInTable: true,
      valueType: 'select',
      request: async () => {
        // 拿到建工的全部商品业态
        const req: any = {
          ProvinceCode: currentUser?.ProvinceCode,
          ServerpartId: "",
          ShopTrade: "",
          BusinessType: "",
          ExcludeShopTrade: "",
          ExcludeBusinessType: ""
        }
        const data = await handleGetServerpartShopTrade(req)
        console.log('data321312', data)
        return data
        // const data = await getFieldEnumTree({ FieldExplainField: 'BUSINESSTYPE' }) 
        // console.log('data', data)
        // return data
      }
    },
    {
      title: '序号',
      width: 120,
      hideInSearch: true,
      dataIndex: 'index',
      valueType: "index",
      align: 'center'
    },
    {
      title: '商品类型',
      width: 200,
      ellipsis: true,
      hideInSearch: true,
      dataIndex: 'CommodityType_Name',
      align: 'center'
    },
    {
      title: <div style={{ textAlign: 'center' }}>销售数量</div>,
      width: 120,
      valueType: 'digit',
      hideInSearch: true,
      ellipsis: true,
      dataIndex: 'Total_Count',
      align: 'right'
    },
    {
      title: <div style={{ textAlign: 'center' }}>优惠金额</div>,
      width: 120,
      valueType: 'digit',
      ellipsis: true,
      align: 'right',
      hideInSearch: true,
      dataIndex: 'Total_OffAmount',
    },
    {
      title: <div style={{ textAlign: 'center' }}>对客营收</div>,
      width: 120,
      valueType: 'digit',
      ellipsis: true,
      align: 'right',
      hideInSearch: true,
      dataIndex: 'Total_SellAmount',
    },
    {
      title: <div style={{ textAlign: 'center' }}>营收占比</div>,
      hideInSearch: true,
      width: 120,
      valueType: 'digit',
      ellipsis: true,
      align: 'right',
      dataIndex: 'Total_SellAmountRate',
      render: (_, record) => {
        return record?.Total_SellAmountRate ? `${record?.Total_SellAmountRate}%` : '-'
      }
    },
  ]

  const exportTable = (e) => {
    e.stopPropagation();                                            // 防止Collapse组件收起
    const main = document.getElementsByClassName(`saleTypeReportHideBox${printIndex}`)[0]
    const thead = main.querySelector('thead').cloneNode(true);  // 深克隆DOM节点
    const tbody = main.querySelector('tbody').cloneNode(true);  // 深克隆DOM节点
    const container = document.querySelector('#hiddenBox');

    const tempTable = document.createElement('table');
    tempTable.appendChild(thead);
    tempTable.appendChild(tbody);

    tempTable.setAttribute('id', 'table-to-xls-saleTypeReport');                    // 给table添加id，值与按钮上的table字段对应

    container.appendChild(tempTable);                                // 把创建的节点添加到页面容器中

    setShowLoading(false)

    downloadBtnRef.current.handleDownload();
    setShowExportTable(false)
    tempTable.remove() // 防止重复打印一个内容
  }
  // 查询的条件
  const [searchParams, setSearchParams] = useState<any>()

  return (
    <div ref={(el) => {
      // 打印报表
      if (!reqDetailList || reqDetailList.length === 0) return;
      setPrintOut(el);
    }} >

      {
        showLoading ?
          <div
            style={{
              width: '100%',
              height: '100%',
              background: 'rgba(0,0,0,0.1)',
              position: 'fixed',
              zIndex: 5,
              display: 'flex',
              alignItems: 'center',
              justifyContent: 'center'
            }}
          >
            <div style={{
              display: 'flex',
              alignItems: 'center',
              justifyContent: 'center',
              padding: '15px 20px 10px',
              background: '#fff',
              borderRadius: '8px',
              width: '200px'
            }}>
              <Spin />
              <span style={{ marginLeft: '5px' }}>数据导出中...</span>
            </div>
          </div> : ''
      }

      <div className={`saleTypeReportHideBox${printIndex}`} style={{ position: 'fixed', zIndex: -1, top: 0, left: 0 }}>
        {
          showExportTable && reqDetailList && reqDetailList.length > 0 ?
            <ProTable
              columns={columns}
              dataSource={reqDetailList}
              pagination={false}
              expandable={{
                defaultExpandAllRows: true
              }}
            /> : ''
        }
      </div>
      <div id='hiddenBox' style={{ position: 'fixed', zIndex: -1, top: 0, left: 0 }} />

      <div style={{ backgroundColor: '#fff', display: 'flex' }}>
        <ProCard
          style={{ width: !collapsible ? "300px" : "60px" }}
          className="pageTable-leftnav"
          bodyStyle={{ padding: 0, paddingTop: 20, paddingLeft: 20, width: !collapsible ? "300px" : "60px" }}
          extra={<MenuFoldOutlined onClick={() => {
            setCollapsible(!collapsible)
          }} />}
          colSpan={!collapsible ? "300px" : "60px"}
          title={!collapsible ? "请选择服务区" : ""}
          headerBordered
          collapsed={collapsible}
        >
          {treeView && treeView.length > 0 ? <Tree
            checkable
            treeData={[{
              label: '全部',
              value: 0,
              key: '0-0',
              children: treeView
            }]}
            fieldNames={{
              title: "label",
              key: "key"
            }}
            blockNode
            defaultExpandedKeys={['0-0']}
            onCheck={(checkedKeys: React.Key[] | any, info) => {
              const selectedIds = info.checkedNodes.filter(n => n?.type === 2)
              setSelectedId(selectedIds.map(n => n?.value)?.toString() || '')
              // actionRef?.current?.reload()
              // getData(selectedIds.map(n => n?.value)?.toString() || '')
            }}
          // switcherIcon={<PlusOutlined />}
          /> : ''}
        </ProCard>
        <div style={{
          width: !collapsible ? 'calc(100% - 300px)' : 'calc(100% - 60px)',
          paddingTop: 0,
          paddingBottom: 0,
          paddingRight: 0
        }}>
          <ProTable
            actionRef={actionRef}
            formRef={formRef}
            columns={columns}
            bordered
            headerTitle={<PageTitleBox props={props} />}
            search={{ span: 6, defaultCollapsed: false }}
            pagination={false}
            scroll={{ y: 'calc(100vh - 520px)' }}
            request={async (params) => {
              console.log('paramsparamsparams', params);

              if (isFirst) {
                setIsFirst(false)
                return
              }
              if (!selectedId) {
                message.error('请选择门店')
                return
              }
              setSearchParams(params)
              handleCallLogs()
              const req = {
                ...params,
                ServerpartShopIds: selectedId,
                commodityType: commodityTypeValue
              }
              console.log('req', req)
              const data = await handleGetCommodityTypeSummary(req)
              console.log('data', data)
              let list: any = []
              if (data && data.length > 0) {
                data.forEach((item: any, index: number) => {
                  item.index = index + 1
                })
                list = data
              }

              let fieldData: any = [
                "Total_Count",
                "Total_OffAmount",
                "Total_SellAmount",
              ]
              let enumList: any = []
              let newPrintData: any = formatTreeData(list, fieldData, enumList, [], ['Total_SellAmountRate'])

              setReqDetailList(newPrintData)
              setTableData(list)
              return { data: list, success: true }
            }}
            toolbar={{
              actions: [
                // <span style={{ visibility: 'hidden' }}>
                //   <ReactHTMLTableToExcel
                //     buttonText={'导出excel'}
                //     ref={downloadBtnRef}
                //     table="table-to-xls-saleTypeReport"
                //     filename={`类别统计报表${searchParams?.startDate}-${searchParams?.endDate}`}
                //     sheet="sheet1"
                //   />
                // </span>,
                <Button
                  key="new"
                  type="primary"
                  onClick={(e) => {
                    if (reqDetailList && reqDetailList.length > 0) {
                      // 尝试一下 导出新方法 
                      exportXlsxFromProColumnsExcelJS(columns,
                        reqDetailList,
                        `销售类别报表${searchParams?.startDate}-${searchParams?.endDate}`,
                        {
                          footerMaker: currentUser?.Name,
                          footerMakerTime: moment().format('YYYY-MM-DD HH:mm:ss'),
                          footerStatsTime: ""
                          // topTitle: `营收汇总报表`, // 顶部大标题
                        }
                      )
                    } else {
                      message.error('暂无数据可导出！')
                    }
                    // if (reqDetailList && reqDetailList.length > 0) {
                    //   setShowLoading(true)
                    //   setTimeout(() => {
                    //     setShowExportTable(true)
                    //     setTimeout(() => {
                    //       exportTable(e)
                    //     }, 100)
                    //   }, 100)
                    // } else {
                    //   message.error('暂无数据可导出！')
                    // }
                  }}
                >
                  导出excel
                </Button>
              ]
            }}
            tableExtraRender={() => {
              if (tableData && tableData.length > 0) {
                let Total_CountSum: number = 0
                let Total_OffAmountSum: number = 0
                let Total_SellAmountSum: number = 0

                tableData.forEach((item: any) => {
                  Total_CountSum += item.Total_Count
                  Total_OffAmountSum += item.Total_OffAmount
                  Total_SellAmountSum += item.Total_SellAmount
                })
                return <div style={{ paddingLeft: 30, paddingBottom: 0 }}>
                  <ProDescriptions column={4} className="commity-sale-description" labelStyle={{ color: "#00000073" }}>
                    <ProDescriptions.Item label="销售数量" contentStyle={{ color: 'orangered' }}>{Total_CountSum ? numeral(Total_CountSum).format('0,0.00') : '0'}</ProDescriptions.Item>
                    <ProDescriptions.Item label="优惠金额" valueType="money" contentStyle={{ color: 'orangered' }}>{Total_OffAmountSum || '0.00'}</ProDescriptions.Item>
                    <ProDescriptions.Item label="对客营收" valueType="money" contentStyle={{ color: 'orangered' }}>{Total_SellAmountSum}</ProDescriptions.Item>
                  </ProDescriptions>
                  <ProDescriptions column={4} className="commity-sale-description" labelStyle={{ color: "#00000073" }}>
                    <ProDescriptions.Item label="制单人员">{currentUser.Name}</ProDescriptions.Item>
                    <ProDescriptions.Item label="制单时间">{moment().format('YYYY-MM-DD HH:mm:ss')}</ProDescriptions.Item>
                    <ProDescriptions.Item label="统计时间">{`${moment(searchParams?.startDate).format('YYYY-MM-DD')}至${moment(searchParams?.endDate).format('YYYY-MM-DD')}`}</ProDescriptions.Item>
                  </ProDescriptions>
                </div>
              }
            }}
          />
        </div>
      </div>
    </div>
  )
}

export default connect(({ user }: ConnectState) => ({
  currentUser: user.currentUser
}))(saleReport);
